<template>
  <div>
    <div class="subtitle-2">
      <strong>{{ data.params.descripcion }}</strong
      ><span class="tRojo">*</span>
    </div>
    <v-autocomplete
      v-model="selected"
      :items="nivelesModelosNegociosFiltered"
      item-text="descripcion"
      item-value="idArbol"
      :label="'Selecciona el ' + data.params.descripcion"
      single-line
      return-object
      :error="data.validator.$error"
    >
      <template v-if="data.validator.$error" v-slot:append-outer>
        <v-popover placement="bottom-end" offset="16">
          <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
          <template slot="popover">
            <div @click="data.validator.$reset()" v-close-popover>
              <span v-if="!data.validator.required"
                >¡No te olvides de éste campo!</span
              >
            </div>
          </template>
        </v-popover>
      </template>
    </v-autocomplete>
  </div>
</template>
<script>
import store from "@/store";
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-Nivel",
  props: ["value", "nivel", "idModeloNegocioPadre", "nodes"],
  watch: {
    idModeloNegocioPadre: {
      deep: true,
      handler(val, pre) {
        this.data.value = {};
        this.$emit("input", this.data);
        if (val) {
          this.loadChildren(val);
        } else {
          this.nivelesModelosNegociosFiltered = [];
        }
      },
    },
    data: {
      deep: true,
      handler(val, prev) {
        this.$emit("input", val);
      },
    },
    selected(val) {
      if (val) {
        val.hasChildren = true;
        val.hasChildren = this.hasChildren(val.idArbol);
      }
      this.data.value = val;
      this.$emit("input", this.data);
    },
  },
  computed: {
    data: {
      get() {
        return this.value;
      },
      set(value) {
        this.$emit("input", value);
      },
    },
  },
  data() {
    return {
      selected: null,
      nivelesModelosNegociosFiltered: [],
      nivelesModelosNegocios: [],
    };
  },
  methods: {
    loadChildren(idParent) {
      const nivelesModelosNegociosData = JSON.parse(
        JSON.stringify(this.nivelesModelosNegocios)
      );
      this.nivelesModelosNegociosFiltered = nivelesModelosNegociosData.filter(
        (itemNivel) => itemNivel.idModeloNegocioPadre == idParent
      );
      this.data.hasElements = this.nivelesModelosNegociosFiltered.length > 0;
      this.$emit("input", this.data);
    },
    hasChildren(idParent) {
      const nivelesModelosNegociosData = JSON.parse(
        JSON.stringify(this.nivelesModelosNegocios)
      );
      let nivelesModelosNegociosChildren = nivelesModelosNegociosData.filter(
        (itemNivel) => itemNivel.idModeloNegocioPadre == idParent
      );
      return nivelesModelosNegociosChildren.length > 0;
    },
    getNiveles() {
      var self = this;
      axios("/modelo-negocio/arbol-negocio/v1/")
        .then((response) => {
          let data = response.data;
          if (data) {
            self.nivelesModelosNegocios = data.resultado.arboles;
            this.$emit("loadData", data.resultado.arboles);
            self.nivelesModelosNegociosFiltered = data.resultado.arboles.filter(
              (itemNivel) =>
                itemNivel.idArbol != 1 && itemNivel.idNivel == this.nivel
            );
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
  },
  created() {
    if (this.nodes && this.nodes.length > 0) {
      this.nivelesModelosNegocios = this.nodes;
      this.loadChildren(this.idModeloNegocioPadre);
    } else {
      this.getNiveles();
    }
  },
};
</script>
